<?php

/**
 * Asterisk SugarCRM Integration
 * (c) KINAMU Business Solutions AG 2009
 *
 * Parts of this code are (c) 2006. RustyBrick, Inc.  http://www.rustybrick.com/
 * Parts of this code are (c) 2008 vertico software GmbH
 * Parts of this code are (c) 2009 abcona e. K. Angelo Malaguarnera E-Mail admin@abcona.de
 * http://www.sugarforge.org/projects/yaai/
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 *
 * You can contact KINAMU Business Solutions AG at office@kinamu.com
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 *
 */
if(!defined('sugarEntry'))define('sugarEntry', true);

function pre_install() {

   require_once('include/utils.php');

   // creates logic hook that inserts Asterisk JavaScript into every UI frame
   check_logic_hook_file("", "after_ui_frame",
   		array(1, 'Asterisk', 'modules/Asterisk/include/AsteriskJS.php','AsteriskJS', 'echoJavaScript'));

   // creates Asterisk logging table
    if (empty($db)) {
        if (!class_exists('PearDatabase')) {
            die("no db available");
        }
        $db = & PearDatabase::getInstance();
    }

	$query = "DROP TABLE IF EXISTS asterisk_log";
	$db->query($query, false, "Error dropping call table: " . $query);

	$query = "CREATE TABLE asterisk_log (";
	$query .= "id int(10) unsigned NOT NULL auto_increment,";
	$query .= "call_record_id char(36) default NULL,";
	$query .= "asterisk_id varchar(45) default NULL,";
	$query .= "callstate varchar(10) default NULL,";
	$query .= "callerID varchar(45) default NULL,";
	$query .= "callerName varchar(45) default NULL,";
	$query .= "channel varchar(30) default NULL,";
	// $query .= "timestampCall varchar(30) default NULL,";
	// $query .= "timestampLink varchar(30) default NULL,";
	// $query .= "timestampHangup varchar(30) default NULL,";
	$query .= "timestampCall datetime default NULL,";
	$query .= "timestampLink datetime default NULL,";
	$query .= "timestampHangup datetime default NULL,";
	$query .= "direction varchar(1) default NULL,";
	$query .= "hangup_cause integer default NULL,";
	$query .= "hangup_cause_txt varchar(45) default NULL,";
	$query .= "PRIMARY KEY (id)";
	$query .= ")";

	$db->query($query, false, "Error creating call table: " . $query);
}

?>